/* Faan Tone Liu
 * Demo program from 1671
 * Inputs integers from the user until they type in a 0
 * Handles errors in input better than the previous version - if an input
 * error is found, it resets cin to allow further input, and clears the
 * bad characters from the input buffer
 */
#include <iostream>
using namespace std;

int main()
{
    int innum(1);   // initialize so that loop executes at least once - this
                    // is not the most elegant way to organize the loop
    char flushchar; // variable to store the bad characters user inputs

    while (innum != 0) {
        // get a number
        cout << "Please input an integer, 0 to quit: ";
        cin >> innum;
        // if input was unsuccessful
        if (!cin) {
            // give an error message
            cout << "No, you did not input an INTEGER." << endl;
            // clear cin's flags
            cin.clear(0);
            // throw away all of the user's input up to the newline
            cin.get(flushchar);
            while (flushchar != '\n') {
                cin.get(flushchar);
            }
        } else {
            // add code here to process innum, provided it's not zero
        }
    }
    cout << "Quitting..." << endl;
}
